# 预习思考题
翻译自[COS 318: Reading Questions](http://www.cs.princeton.edu/courses/archive/fall08/cos318/reading/questions.html)
## MOS 1.4-1.5
*目标*：理解操作系统的职能、组成和提供的服务。
- BIOS通常存储在闪存中。是否有可能将BIOS存储在磁盘上？请简要概述在闪存和磁盘上存储BIOS的利弊。
- 引导操作系统最简单的方式是从磁盘上的二进制镜像启动。如果要搭建无盘工作站，即从网络上的文件服务器获取引导程序的网络计算机应该怎么办？简单讲讲你的想法。

## MOS 1.6-1.7
*目标*：理解操作系统结构，以及系统调用和库调用的实现。
- 系统调用与库调用的区别是什么？
- 微内核的利弊有哪些？

## MOS 2.1-2.2
*目标*：理解程序、进程和线程的概念。
- 程序和进程的区别是什么？
- 进程和线程的区别是什么？
- 写出进程上下文切换的伪代码。

## MOS 2.2.3-2.3.3
*目标*：理解不同类型的线程和临界区的概念。
- 内核线程与用户线程的区别是什么？
- 有两名学生同住一间公寓，他们共同承担买牛奶的责任，但是冰箱比较小，所以他们不想买太多牛奶。有一天：

| 时间 | 学生A                    | 学生B                                  |
|------|--------------------------|----------------------------------------|
| 3:00 | 看了看冰箱，发现没牛奶。 |                                        |
| 3:05 | 骑自行车去超市           |                                        |
| 3:10 | 抵达超市                 | 倒上了麦片，打开冰箱发现没牛奶。       |
| 3:15 | 买牛奶                   | 开车去超市                             |
| 3:20 | 回到住处把牛奶放进了冰箱 | 抵达超市                               |
| 3:25 |                          | 买牛奶                                 |
| 3:30 |                          | 回到住处把牛奶倒进麦片，然后放进冰箱。 |

每一步学生都有可能会被暂时打断去做别的事。你会怎么解决这个问题？

## MOS 2.3.3, 2.3.6
*目标*：理解如何通过关中断和原子的读取-修改-写入操作实现互斥访问。
- 实现`Acquire()`和`Release()`操作最简单的方式是：
```
Acquire() {
  关中断;
}
Release()
{
  开中断;
}
```
你觉得这样可行吗？如果可行，需要满足怎样的条件？如果不行，解释原因并说明如何修正。
- 教材提到可以利用检查并设置（test-and-set）指令实现互斥访问。怎样利用它实现`Acquire()`和`Release()`操作？
